Codeforces Round #331 (Div. 2)C. Wilbur and Points

题目解释:n个点对,n个数,要求求出是否存在一个增序列满足答案,并输出。

(集合规则:如果(x,y)在集合里,那么(0,0)到(x,y-1),(x-1,y)也在集合里

输入的时候也是)

首先怎么暴力怎么来,我们先对n个点对进行分类(根据差值分类),然后每一类分别从小到大排序。然后目前的解就是一次填充n个数,因为小的肯定在大的前面被填充,否则就不符合集合的定义。

然后进行判断,因为数据点没有突变,只要严格意义上不比前一个数大就行,因为都是连续的数据段。

#include<cstdio>
#include<algorithm>
#include<cmath>
#include<map>
#include<iostream>
#include<vector>
#include<cstring>
#include<queue>
#include<string>
using namespace std;
int n;
struct node1
{
    int x,y,c;
}a[100005];
int f[200005];
int c[100005];
vector<int> g[200005];
int ans[100005];
bool cmp1(const int xx,const int yy)
{
    if(a[xx].x<a[yy].x)
        return 1;
    return 0;
}

int main()
{
    //freopen("input.txt","r",stdin);
   scanf("%d",&n);
   for(int i=0;i<n;i++)
   {
    scanf("%d%d",&a[i].x,&a[i].y);
    a[i].c=a[i].y-a[i].x;
    g[a[i].c+100000].push_back(i);
   }
   for(int i=0;i<=200002;i++)
   sort(g[i].begin(),g[i].end(),cmp1);
   int t;
   int flag=1;
   for(int i=0;i<n;i++){
    scanf("%d",&t);
    c[i]=t;
    if(flag){

    if(f[t+100000]==g[t+100000].size())
        {flag=0;
        break;
        }
 ans[i]=g[t+100000][f[t+100000]];
    f[t+100000]++;}
   }
   if(!flag)
   {
    printf("NO\n");
    return 0;
   }
   else
   {
      for(int i=1;i<n;i++)
      {
          int t1=a[ans[i]].x;
          int t2=a[ans[i]].y;
          int t3=a[ans[i-1]].x;
          int t4=a[ans[i-1]].y;
          if((t3>t1&&t4>=t2)||((t3>=t1&&t4>t2)))
          {
               printf("NO\n");
                return 0;
          }
      }
      printf("YES\n");
      for(int i=0;i<n;i++)
        printf("%d %d\n",a[ans[i]].x,a[ans[i]].y);
   }
}
时间: 2025-01-01 04:53:50

Codeforces Round #331 (Div. 2)C. Wilbur and Points的相关文章

Codeforces Round #331 (Div. 2)

A 8min -1 日常WA签到题.看清数据范围啊. B 7min \(ans=\sum |a_i-a_{i-1}|\) C 33min 对于每个\(y-x=w\)的条件,建一个堆.从大到小,依次分配编号,每次取出\(w\)对应的堆顶元素. 接下来我们check得到的解是否合法.解合法只需任何点,左下方所有点编号的最大值,都小于这个点的编号. 然后对所有点先按\(x\),再按\(y\)排序,遍历数组的同时,按\(y\)将点的编号,插入BIT.用这个BIT维护前缀最大值即可. D 109min \

Codeforces Round #279 (Div. 2) ABCD

Codeforces Round #279 (Div. 2) 做得我都变绿了! Problems # Name     A Team Olympiad standard input/output 1 s, 256 MB  x2377 B Queue standard input/output 2 s, 256 MB  x1250 C Hacking Cypher standard input/output 1 s, 256 MB  x740 D Chocolate standard input/

Codeforces Round #633 (Div. 2)

Codeforces Round #633(Div.2) \(A.Filling\ Diamonds\) 答案就是构成的六边形数量+1 //#pragma GCC optimize("O3") //#pragma comment(linker, "/STACK:1024000000,1024000000") #include<bits/stdc++.h> using namespace std; function<void(void)> __

Codeforces Round #428 (Div. 2)

Codeforces Round #428 (Div. 2) A    看懂题目意思就知道做了 #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; ++i) #define per(i,b,a) for (int i=b; i>=a; --i

Codeforces Round #424 (Div. 2) D. Office Keys(dp)

题目链接:Codeforces Round #424 (Div. 2) D. Office Keys 题意: 在一条轴上有n个人,和m个钥匙,门在s位置. 现在每个人走单位距离需要单位时间. 每个钥匙只能被一个人拿. 求全部的人拿到钥匙并且走到门的最短时间. 题解: 显然没有交叉的情况,因为如果交叉的话可能不是最优解. 然后考虑dp[i][j]表示第i个人拿了第j把钥匙,然后 dp[i][j]=max(val(i,j),min(dp[i-1][i-1~j]))   val(i,j)表示第i个人拿

Codeforces Round #424 (Div. 2) C. Jury Marks(乱搞)

题目链接:Codeforces Round #424 (Div. 2) C. Jury Marks 题意: 给你一个有n个数序列,现在让你确定一个x,使得x通过挨着加这个序列的每一个数能出现所有给出的k个数. 问合法的x有多少个.题目保证这k个数完全不同. 题解: 显然,要将这n个数求一下前缀和,并且排一下序,这样,能出现的数就可以表示为x+a,x+b,x+c了. 这里 x+a,x+b,x+c是递增的.这里我把这个序列叫做A序列 然后对于给出的k个数,我们也排一下序,这里我把它叫做B序列,如果我

[Codeforces] Round #352 (Div. 2)

人生不止眼前的狗血,还有远方的狗带 A题B题一如既往的丝帛题 A题题意:询问按照12345678910111213...的顺序排列下去第n(n<=10^3)个数是多少 题解:打表,输出 1 #include<bits/stdc++.h> 2 using namespace std; 3 int dig[10],A[1005]; 4 int main(){ 5 int aa=0; 6 for(int i=1;;i++){ 7 int x=i,dd=0; 8 while(x)dig[++dd

Codeforces Round #273 (Div. 2)

Codeforces Round #273 (Div. 2) 题目链接 A:签到,仅仅要推断总和是不是5的倍数就可以,注意推断0的情况 B:最大值的情况是每一个集合先放1个,剩下都丢到一个集合去,最小值是尽量平均去分 C:假如3种球从小到大是a, b, c,那么假设(a + b) 2 <= c这个比較明显答案就是a + b了.由于c肯定要剩余了,假设(a + b)2 > c的话,就肯定能构造出最优的(a + b + c) / 3,由于肯定能够先拿a和b去消除c,而且控制a和b成2倍关系或者消除

Codeforces Round #339 (Div. 2) B. Gena&#39;s Code

B. Gena's Code It's the year 4527 and the tanks game that we all know and love still exists. There also exists Great Gena's code, written in 2016. The problem this code solves is: given the number of tanks that go into the battle from each country, f